﻿unit OPWINDOWS;

interface

　　uses

　　Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,

　　ExtCtrls, StdCtrls,shlobj,shellapi,ActiveX;

　　type

　　Tform2 = class(TForm)

　　ListBox1: TListBox;

　　Button1: TButton;

　　Button2: TButton;

　　procedure FormCreate(Sender: TObject);

　　procedure FormClose(Sender: TObject; var Action: TCloseAction);

　　procedure Button1Click(Sender: TObject);

　　procedure Button2Click(Sender: TObject);

　　private

　　{ Private declarations }

　　public

　　FileList:TStringList;

　　{ Public declarations }

　　end;

　　var

　　Form2: Tform2;

　　implementation

　　{＄R ＊.DFM}

　　procedure Tform2.FormCreate(Sender: TObject);

　　begin

　　FileList:=TStringList.Create;

　　Button1.Caption :=’复制文件’;

　　Button2.Caption :=’移动文件’;

　　Self.Show;

　　end;

　　procedure Tform2.FormClose(Sender: TObject; var Action: TCloseAction);

　　begin

　　FileList.Free;

　　end;

　　procedure Tform2.Button1Click(Sender: TObject);

　　var

　　sPath:string;

　　fsTemp:SHFILEOPSTRUCT;

　　i:integer;

　　begin

　　sPath:=InputBox(’文件操作’,’输入复制路径’,’c:\windows’);

　　if sPath<>’then begin

　　fsTemp.Wnd := Self.Handle;

　　//设置文件操作类型

　　fsTemp.wFunc :=FO_COPY;

　　//允许执行撤消操作

　　fsTemp.fFlags :=FOF－ALLOWUNDO;

　　for i:=0 to ListBox1.Items.Count－1 do begin

　　//源文件全路径名

　　fsTemp.pFrom := PChar(ListBox1.Items.Strings[i]);

　　//要复制到的路径

　　fsTemp.pTo := PChar(sPath);

　　fsTemp.lpszProgressTitle:=’拷贝文件’;

　　if SHFileOperation(fsTemp)<>0 then

　　ShowMessage(’文件复制失败’);

　　end;

　　end;

　　end;

　　procedure Tform2.Button2Click(Sender: TObject);

　　var

　　sPath:string;

　　fsTemp:SHFILEOPSTRUCT;

　　i:integer;

　　begin

　　sPath:=InputBox(’文件操作’,’输入移动路径’,’c:\windows’);

　　if sPath<>’then begin

　　fsTemp.Wnd := Self.Handle;

　　fsTemp.wFunc :=FO_MOVE;

　　fsTemp.fFlags :=FOF_ALLOWUNDO;

　　for i:=0 to ListBox1.Items.Count－1 do begin

　　fsTemp.pFrom := PChar(ListBox1.Items.Strings[i]);

　　fsTemp.pTo := PChar(sPath);

　　fsTemp.lpszProgressTitle:=’移动文件’;

　　if SHFileOperation(fsTemp)<>0 then

　　ShowMessage(’文件复制失败’);

　　end;

　　end;

　　end;

　　end.


