
unit ContextMenuHandle;

interface

uses
    //Windows,ActiveX,ComObj,ShlObj,Classes,dialogs;    Interfaces,
    Classes, ComServ,  ActiveX,  ShlObj, Menus,  Messages,
     SysUtils, Variants,  Graphics, Controls, Forms,ShellAPI, registry,
     winapi.Windows,  ComObj, dialogs, DateUtils,mmsystem;


type
   TContextMenu = class(TComObject,IShellExtInit,IContextMenu)

private
    FFileName: array[0..MAX_PATH] of Char;
protected

@@function IShellExtInit.Initialize = SEIInitialize; // Avoid compiler warning

@@function SEIInitialize(pidlFolder: PItemIDList; lpdobj: IDataObject;

@@hKeyProgID: HKEY): HResult; stdcall;

@@function QueryContextMenu(Menu: HMENU; indexMenu, idCmdFirst, idCmdLast,

@@uFlags: UINT): HResult; stdcall;

@@function InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult; stdcall;

@@function GetCommandString(idCmd, uType: UINT; pwReserved: PUINT;

@@pszName: LPSTR; cchMax: UINT): HResult; stdcall;

@@end;

@@const

@@Class_ContextMenu: TGUID = {19741013C82911D182330020AF3E97A0};

@@{ߤ@ѧOr(GUID)O@16줸ա]128^ȡAߤ@aѤ@Ӥ(interface)}

@@var

@@FileList:TStringList;

@@implementation

@@uses ComServ, SysUtils, ShellApi, Registry,UnitForm;

@@function TContextMenu.SEIInitialize(pidlFolder: PItemIDList; lpdobj: IDataObject;

@@hKeyProgID: HKEY): HResult;

@@var

@@StgMedium: TStgMedium;

@@FormatEtc: TFormatEtc;

@@FileNumber,i:Integer;

@@begin

@@//pGlpdobjNilAhեΥ

@@if (lpdobj = nil) then begin

@@Result := E_INVALIDARG;

@@Exit;

@@end;

@@//lƨòMFileListHK[

@@FileList:=TStringList.Create;

@@FileList.Clear;

@@//lưŶK榡

@@with FormatEtc do begin

@@cfFormat := CF_HDROP;

@@ptd := nil;

@@dwAspect := DVASPECT_CONTENT;

@@lindex := 1;

@@tymed := TYMED_HGLOBAL;

@@end;

@@Result := lpdobj.GetData(FormatEtc, StgMedium);

@@if Failed(Result) then Exit;

@@//dߥΤ襤ɪӼ

@@FileNumber := DragQueryFile(StgMedium.hGlobal,CFFFFFFFF,nil,0);

@@//jŪANҦΤ襤ɫOsFileList

@@for i:=0 to FileNumber1 do begin

@@DragQueryFile(StgMedium.hGlobal, i, FFileName, SizeOf(FFileName));

@@FileList.Add(FFileName);

@@Result := NOERROR;

@@end;

@@ReleaseStgMedium(StgMedium);

@@end;

@@function TContextMenu.QueryContextMenu(Menu: HMENU; indexMenu, idCmdFirst,

@@idCmdLast, uFlags: UINT): HResult;

@@begin

@@Result := 0;

@@if ((uFlags and C0000000F) = CMFNORMAL) or

@@((uFlags and CMF_EXPLORE) <> 0) then begin

@@// Context Menu[J@ӥ\ ,\DI}

@@InsertMenu(Menu, indexMenu, MF_STRING or MF_BYPOSITION, idCmdFirst,

@@PChar(ɾާ@));

@@// ^W[涵Ӽ

@@Result := 1;

@@end;

@@end;

@@function TContextMenu.InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult;

@@var

@@frmOP:TForm1;

@@begin

@@// TwӹL{OQtΦӤOQ@ӵ{ҽե

@@if (HiWord(Integer(lpici.lpVerb)) <> 0) then

@@begin

@@Result := E_FAIL;

@@Exit;

@@end;

@@// TwǻѼƪĩ

@@if (LoWord(lpici.lpVerb) <> 0) then begin

@@Result := E_INVALIDARG;

@@Exit;

@@end;

@@//إɾާ@

@@frmOP:=TForm1.Create(nil);

@@//NҦɦCK[ɾާ@C

@@frmOP.ListBox1.Items := FileList;

@@Result := NOERROR;

@@end;

@@function TContextMenu.GetCommandString(idCmd, uType: UINT; pwReserved: PUINT;

@@pszName: LPSTR; cchMax: UINT): HRESULT;

@@begin

@@if (idCmd = 0) then begin

@@if (uType = GCS_HELPTEXT) then

@@{^ӥ\UTAUTNbΤƹ

@@ʨӥ\ɥX{bAWC}

@@StrCopy(pszName, PChar(Iӥ\Nɾާ@));

@@Result := NOERROR;

@@end

@@else

@@Result := E_INVALIDARG;

@@end;

@@type

@@TContext Menu Factory =class(TCom Object Factory)

@@public

@@procedure UpdateRegistry(Register: Boolean); override;

@@end;

@@procedure TContextMenuFactory.UpdateRegistry(Register: Boolean);

@@var

@@ClassID: string;

@@begin

@@if Register then begin

@@inherited UpdateRegistry(Register);

@@ClassID := GUIDToString(ClassContextMenu);

@@//UXiwɮɡAK[wU

@@CreateRegKey(\shellex, , );

@@CreateRegKey(\shellex\ContextMenuHandlers, , );

@@CreateRegKey(\shellex\ContextMenuHandlers\FileOpreation, , ClassID);

@@//pG@~tάWindows NT

@@if (Win32Platform = VERPLATFORMWIN32NT) then

@@with TRegistry.Create do

@@try

@@RootKey := HKEYLOCALMACHINE;

@@OpenKey(SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions, True);

@@OpenKey(Approved, True);

@@WriteString(ClassID, Context Menu Shell Extension);

@@finally

@@Free;

@@end;

@@end

@@else begin

@@DeleteRegKey(\shellex\ContextMenuHandlers\FileOpreation);

@@inherited UpdateRegistry(Register);

@@end;

@@end;

@@initialization

@@TContext Menu Factory.Create(Com Server, TContextMenu, ClassContextMenu,, Context Menu Shell Extension, ciMultiInstance,tmApartment);

@@end.

